# db_samvaad By :
[![Solid](http://elucidata.io/static/images/logo.png)](http://elucidata.io/)

### Objective
db_samvaad is the library which is used to make the specific mostly used db queries to mithoo database. The main advantage of using db_samvaad is that programmers need not to worry for unwanted dangling DB connections. It abstracts all management stuff by itself.


### Features
**Following are the list of the features db samvaad provides**

* _Database Connection creation_ : Abstracts out the db creation. Programmers can just create the instance of DatabaseHandle class and get their work done by calling various functions according to respective requirements.

* _No Dangling Connections_ : It ensures that programmer need not to create the multiple DB connections in their project while interating with DB at different places

* _query flexibility_ : It provide the db operations specific to mithoo database along with the power of executing custom queries(Eg. joins, nested queries etc.).

### installation
`pip install --index-url=http://54.245.179.143:80 --trusted-host 54.245.179.143 db_samvaad `

### Functions
* Mithoo Specific functions:
    * _get_value_from_iter_id(iter_id,column_name)_ : To get the value of a column for iteration id iter_id
    * _update_state(iter_id,state)_ : To update the state of the an iteration.
    * _update_heartbeat(iter_id,percentage)_ : To update the heartbeat of an iteration.
    * _get_task_name_from_algo(algo_name, task_type)_ : To get the task definition name for a particular algorithm

* Custom query functions:
    *  _get_value(table_name,column_name,pr_key)_ : To get the value of a single column `column_name` from table `table_name` with the primary key `pr_key`.
    * _update_value(table_name,column_name,new_value,pr_key)_ : To update the value of a single column `column_name` in table `table_name` having primary key `pr_key` to new value `new_value`.
    * _execute_query(query,arguments)_ : To execute the custom query `query` with the arguments `arguments`.

## Usages
```
import db_samvaad as db_con
from db_samvaad.db_handler import DatabaseHandle

db_con.db =  DatabaseHandle()
table_name = 'users'
name = 'Rohit Negi'
query =  'select * from {0} where name={1}'
arguments = (table_name, name)
data = db_con.db.execute_query(query, arguments)
```
