import os
import boto3
import botocore
from db_samvaad import db_credentials as creds
from db_samvaad import constants

def download_cert():
    """
    this function downloads root certificate from s3 bucket if it
    doesn't exit.

    """
    file_exist = os.path.isfile(constants.CERTIFICATE_PATH + creds.DATABASE_CERTIFICATE)
    
    if not file_exist :
        try:
            s3 = boto3.resource('s3')
        except botocore.exceptions.ClientError as err:
            raise err
        try:
            s3.Bucket(creds.PRIVATE_DATA_BUCKET).download_file(creds.DATABASE_CERTIFICATE, constants.CERTIFICATE_PATH + creds.DATABASE_CERTIFICATE)
        except botocore.exceptions.ClientError as e:
            if e.response['Error']['Code'] == "404":
                print("The object does not exist.")
            else:
                return False
    return True

